*+
*+
*+    Source Module => D:\SRC\READMEM\READMEM.PRG
*+
*+    Functions: Procedure READMEM()
*+
*+    Reformatted by Click! 1.13 on Mar-25-1998 at 11:42 pm
*+
*+

*+
*+
*+    Procedure READMEM()
*+
*+
*+
procedure READMEM( cParm1 )

local cFileName := space( 8 )
local aPickList := {}
local aDirectry := {}
local x
local nChoice   := 0
local aMemVars  := {}
local nLine     := 0
local cOp       := "N"
local nParms    := pcount()
local GetList   := {}

scroll()
setpos( 0, 0 )
dispbox( 0, 0, 24, 79, 1 )
dispbox( 2, 1, 2, 78, 1 )
@  1,  1 say PADC( "MEM Files Browser", 78 )         

do while .T.

   scroll( 23, 1, 23, 78 )
   setpos( 23, 1 )
   aDirectry := {}
   aPickList := {}

   if nParms = 0

      aDirectry := directory( "*.MEM" )
      for x := 1 to len( aDirectry )
         aadd( aPickList, aDirectry[ x, 1 ] )
      next
      asort( aPickList )

      @  3,  1 say padc( "Select a file:", 78 )         
      @ 23,  1 say PADC( "[Esc] to exit", 78 )          
      nChoice := achoice( 5, 34, 21, 45, aPickList )

      if lastkey() = 27
         exit
      elseif nChoice = 0
         scroll()
         setpos( 0, 0 )
         alert( "No [.MEM] files found at this directory." )
         exit
      endif

      cFileName := trim( aPickList[ nChoice ] )

   else

      if upper( right( cParm1, 4 ) ) <> ".MEM"
         cFileName := upper( trim( cParm1 ) + ".mem" )
      else
         cFileName := upper( trim( cParm1 ) )
      endif

      if !file( cFileName )
         alert( "File " + cFileName + "not found" )
         nParms := 0
         loop
      endif

   endif

   scroll( 3, 1, 22, 78 )
   setpos( 3, 1 )
   aMemVars := GETVARFROM( cFileName )
   @  3,  5 say "Name"                       
   @  3, 18 say "Type"                       
   @  3, 23 say "Value"                      
   @  3, 60 say "File: " + cFileName         
   nLine := 4

   for x := 1 to len( aMemVars )

      ++ nLine
      @ nLine,  5 say aMemVars[ x, 1 ]         
      @ nLine, 18 say aMemVars[ x, 2 ]         
      @ nLine, 23 say aMemVars[ x, 3 ]         

      if nLine = 20
         nLine := 3
         inkey( 0 )
         scroll( 3, 1, 20, 78 )
         setpos( 3, 1 )
      endif

      @ 23,  1 say PADC( "Press any key to continue", 78 )         

   next

   inkey( 0 )
   scroll( 3, 1, 23, 78 )
   setpos( 3, 1 )

   if nParms = 1
      @ 23, 20 say "Would you like to browse another file? (Y/N)" get cOp valid ( upper( cOp ) $ 'YN' )       
      read
      if upper( cOp ) = "N"
         exit
      else
         nParms := 0
      endif
   endif

enddo

scroll()

return

*+ EOF: READMEM.PRG
